
#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>

// fuer sei(), cli() und ISR():
#include <avr/interrupt.h>

#include <main.h>
#include <lcd.c>

#include <stdint.h>


#define F_CPU 8000000UL
#include <util/delay.h>      /* definiert _delay_ms() ab avr-libc Version 1.2.0 */


volatile int counter,parity=0x3F;
volatile uint8_t scan1, scan2, scan3, lastscan, Empfang;
//volatile uint16_t  ;





void keyboard_send (uint8_t command) {

	cli(); //1. Interrupts ausschalten
	
	DDRD |= (1 << PD2); //CLOCK Line low, dadurch kein CTS  
	_delay_ms(1);
	
	Empfang = 0;
			
	scan1 = scan2;	//Alte Scancodes um 1 nach hinten verschieben
	scan2 = scan3;
	scan3 = lastscan;
	lastscan = command;	//lastscan mit dem zu bermittelnden Befehl berschreiben

	DDRD |= (1 << PD2); //DATA Line low, d.h. PC will senden
	_delay_ms(1);
	
	DDRD &= ~(1 << PD2); //CLOCK Line 1 ==> CTS
	sei(); //als letztes: Interrupts reaktivieren
}









//Hauptprogramm
int main (void) {


//PORTD ale Eingnge definieren, PULLUPS ausschalten
DDRD = 0x00;
PORTD = 0x00; //aus!!!

DDRD |= (1 << PD2); //CLOCK Line low, dadurch kein CTS  


//PORTA als Ausgnge deklarieren, PA5  high legen
/*DDRA = 0xFF;
PORTA |= (1 << PA5); */

counter = 0;

	LCD_Init();
    LCD_Clear();

//Interrupts aktivieren
MCUCR &= ~(1 << ISC00);
MCUCR |= (1 << ISC01);

GICR |= (1 << INT0);

Empfang = 1;
sei();

DDRD &= ~(1 << PD2); //CLOCK Line 1 ==> CTS

keyboard_send(0xFF); //Reset
while ((lastscan!=0xAA) | (counter!=0)); //Warten bis BAT Completet empfangen
_delay_ms(15);

/*parity=0;

senden:
if (parity==0xFF) { goto abort; }
keyboard_send(parity);
		LCD_Print(0,0,"Counter: %x   ",parity);
_delay_ms(4);
while (counter!=0);
parity++;
if (lastscan==0xFE) { goto senden; }

abort:
*/

//while ((lastscan!=0xFA) | (counter!=0)); //Warten bis Acknowledge empfangen
//_delay_ms(17);
//keyboard_send(0b0011);


//Hauptprogramm luft stndig in einer Schleife
while (1) {
	
		LCD_Print(0,0,"Counter: %i %c  ",counter,parity);
		LCD_Print(1,0,"Scan:%x %x %x %x  ",lastscan,scan3,scan2,scan1);
	
}

return (1);

}



ISR(INT0_vect) {

if (Empfang) {

	switch (counter) {
		
		case (0): //Startbit
			//Hier knnte das Startbit auf 0 geprft werden
			
			scan1 = scan2;	//Alte Scancodes um 1 nach hinten verschieben
			scan2 = scan3;
			scan3 = lastscan;
			lastscan = 0;
			parity = 0;
			
			counter++;
		break;
		
		case (1): case (2): case (3): case (4): case (5): case (6): case (7): case (8):
			if ((PIND & (1 << PD4))) {
				lastscan |= (1 << (counter-1));
				parity++;
			} else {
				lastscan &= ~(1 << (counter-1));
			}
			
			counter++;
		break;
	
		case (9):
			//( parity % 2 == 0);	//Parity berechnen
			//evtl. Parity-Bit prfen
			if ((PIND & (1 << PD4))) {
				parity = 0x50;
			} else {
				parity = 0x2D;
			}
	
			counter++;
		break;
	
		case (10):  //Stoppbit
			//Hier knnte das Stopbit auf 1 geprft werden
	
			counter = 0;
		break;
		
	
	}

} else {

	switch (counter) {
		
		case (0):
			DDRD |= (1 << PD4); //Ausgang --> DATA Line low = 0

			counter++;
		break;
		
		
		case (1): case (2): case (3): case (4): case (5): case (6): case (7): case (8):
			if ((lastscan & (1 << (counter-1)))) {
				DDRD &= ~(1 << PD4); //Eingang --> DATA Line high = 1 
				parity++;
			} else {
				DDRD |= (1 << PD4); //Ausgang --> DATA Line low = 0  
			}
			
			counter++;
		break;
		
		case (9):
			if (( parity % 2 == 1)) {  //ODD Parity berechnen & ausgeben
				DDRD &= ~(1 << PD4); //Eingang --> DATA Line high = 1 
			} else {
				DDRD |= (1 << PD4); //Ausgang --> DATA Line low = 0  
			}
				//DDRD &= ~(1 << PD4); //Eingang --> DATA Line high = 1 

			counter++;
		break;
	
		case (10):  //Stoppbit
			DDRD &= ~(1 << PD4); //Eingang --> DATA Line high = 1 
			counter++;
		break;

		case (11):  
			counter = 0;
			Empfang = 1;	
		break;
		
		default:
			//counter++;
		break;
	}


}

}

